<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Statistiky\Tests\Unit\Entities\Zaznam\ValueObjects;

use InvalidArgumentException;
use Seka\Portal\Modul\Statistiky\Tests\TestCase;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\HodnotenieEmisnejKontrolyEnum;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaHodnotenia;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaKategorieVozidla;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\ZoznamPoctuKontrolPodlaKategorieVozidla;

/**
 * Class ZoznamPoctuKontrolPodlaKategorieVozidlaTest
 *
 * @package Seka\Portal\Modul\Statistiky\Tests\Unit\Entities\Zaznam\ValueObjects
 */
class ZoznamPoctuKontrolPodlaKategorieVozidlaTest extends TestCase
{
    /**
     *
     */
    public function testInstance()
    {
        $zoznam = new ZoznamPoctuKontrolPodlaKategorieVozidla();

        self::assertInstanceOf(ZoznamPoctuKontrolPodlaKategorieVozidla::class, $zoznam);
    }

    /**
     *
     */
    public function testAddInstanciaInejTriedy()
    {
        $zoznam = new ZoznamPoctuKontrolPodlaKategorieVozidla();

        self::expectException(InvalidArgumentException::class);

        $zoznam->add(new PocetKontrolPodlaHodnotenia(
            HodnotenieEmisnejKontrolyEnum::SPOSOBILE(),
            11
        ));

        self::assertTrue(true);
    }

    /**
     *
     */
    public function testAddRovnakyDruhKontroly()
    {
        $zoznam = new ZoznamPoctuKontrolPodlaKategorieVozidla();

        for ($a = 0; $a < 3; ++$a) {
            $pocetKontrolPodlaKategorieVozidla = new PocetKontrolPodlaKategorieVozidla(
                'M1',
                33
            );

            $zoznam->add($pocetKontrolPodlaKategorieVozidla);
        }

        self::assertCount(1, $zoznam);

        for ($a = 0; $a < 3; ++$a) {
            $pocetKontrolPodlaKategorieVozidla = new PocetKontrolPodlaKategorieVozidla(
                'N1',
                3
            );

            $zoznam->add($pocetKontrolPodlaKategorieVozidla);
        }

        self::assertCount(2, $zoznam);

        for ($a = 0; $a < 3; ++$a) {
            $pocetKontrolPodlaKategorieVozidla = new PocetKontrolPodlaKategorieVozidla(
                'N2',
                4
            );

            $zoznam->add($pocetKontrolPodlaKategorieVozidla);
        }

        self::assertCount(3, $zoznam);
    }
}
